/*SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
                                                                                                                        
   ,dSSSSSSSSSSSS  SSSS    ,dSSY'  SSSS      SSSS  SSSS          SSSS  SSSSb,    SSSS  ,dSSSSSSSSSSSS  SSSSSSSSSSSSb,   
   SSSS            SSSS  ,dSSY'    SSSS      SSSS  SSSS          SSSS  SSSSSSb,  SSSS  SSSS            SSSS      SSSS   
   'YSSSSSSSSSSb,  SSSSSSSSSSSSb,  'YSSSSSSSSSSSS  SSSS          SSSS  SSSS'YSSb,SSSS  SSSSSSSSSSS     SSSS      SSSS   
             SSSS  SSSS      SSSS            SSSS  SSSS          SSSS  SSSS  'YSSSSSS  SSSS            SSSS      SSSS   
   SSSSSSSSSSSSP'  SSSS      SSSS  SSSSSSSSSSSSP'  'YSSSSSSSSSS  SSSS  SSSS    'YSSSS  'YSSSSSSSSSSSS  SSSS  SSSSSSP'   
                                                                                                                        
SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
                                                                                                                        
 SploitScripts/Utils 10.9 - A set of tools for browser exploits.                                                        
 Copyright (c) 2003-2010 Berend-Jan "SkyLined" Wever <berendjanwever@gmail.com>                                         
 All rights reserved. This information is provided for academic purpose only.                                           
                                                                                                                        
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the       
 following conditions are met:                                                                                          
    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following  
      disclaimer.                                                                                                       
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the         
      following disclaimer in the documentation and/or other materials provided with the distribution.                  
    * Neither the name of the copyright holder nor the names of the contributors may be used to endorse or promote      
      products derived from this software without specific prior written permission.                                    
                                                                                                                        
 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED  
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     
 HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES    
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR         
 BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE         
 POSSIBILITY OF SUCH DAMAGE.                                                                                            
                                                                                                                        
SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS*/

function strDup(iCount, xInput) {
  // Turn xInput into a string and return iCount concatinated copies of that string:
  return new Array(iCount + 1).join(new String(xInput));
}
function asciiUnicode(xInput) {
  // Turn xInput into an ascii string and encode that string into a unicode
  // string such that the bytes in the unicode string will be the same
  // as the bytes in the ascii string.
  var sAscii = new String(xInput);
  var sUnicode = "";
  for (var i = 0; i < sAscii.length; i += 2) {
    var iCharCode1 = sAscii.charCodeAt(i);
    var iCharCode2 = i + 1 < sAscii.length ? sAscii.charCodeAt(i + 1) : 0;
    sUnicode += String.fromCharCode((iCharCode2 << 8) + iCharCode1);
  }
  return sUnicode;
}
function dwordAscii(iValue) {
  // Encode iValue as a DWORD into 4 ascii characters.
  for (var sValue = ""; sValue.length < 4;)
      sValue += String.fromCharCode(iValue & 0xFF), iValue >>>= 8;
  return sValue;
}
function dwordUnicode(iValue) {
  // Encode iValue as a DWORD into 2 unicode characters.
  for (var uValue = ""; uValue.length < 2;)
      uValue += String.fromCharCode(iValue & 0xFFFF), iValue >>>= 16;
  return uValue;
}

function dwordsUnicode(/*iValue, iValue, ...*/) {
  var uValues = '';
  for (var i = 0; i < arguments.length; i++)
      uValues += dwordUnicode(arguments[i]);
  return uValues;
}

function Structure(asElementDefinitions) {
  var dsiValidTypesAndSizes = {dword:4, word:2, byte:1};
  var asElementNames = [];
  var aiElementTypeSizes = [];
  var aiElementArrayLengths = [];
  var iTotalSize = 0;
  for (var i = 0; i < asElementDefinitions.length; i++) {
    var asElementDefinition = asElementDefinitions[i].match(
        /^\s*(\w+)(?:\[(\d+)\])?\s+(\w+)\s*(?:\=\s*([\[\]\,\s0-9A-Fa-fx]+))?$/);
    var sType = asElementDefinition[1];
    var sArrayLength = asElementDefinition[2];
    var sName = asElementDefinition[3];
    var sValue = asElementDefinition[4];
    var iTypeSize = dsiValidTypesAndSizes[sType.toLowerCase()];
    if (iTypeSize == undefined) throw new Error('Unknown type: "' + sType + '"');
    asElementNames.push(sName);
    aiElementTypeSizes.push(iTypeSize);
    if (sArrayLength == "" || typeof(sArrayLength) === "undefined") {
      aiElementArrayLengths.push(Number.NaN);
      this[sName] = sValue ? parseInt(sValue) : 0;
      iTotalSize += iTypeSize;
    } else {
      var iArrayLength = parseInt(sArrayLength);
      if (isNaN(iArrayLength)) throw new Error(
          'Invalid array length "' + sArrayLength + '" in "' + asElementDefinitions[i] + '"');
      aiElementArrayLengths.push(iArrayLength);
      this[sName] = [];
      if (sValue != undefined) {
        var asValues = sValue.substr(1).split(','); // Skip initial '[', white space and trailing ']' are ignored.
      }
      while (this[sName].length < iArrayLength) {
        var iValue = sValue ? parseInt(asValues[this[sName].length]) : 0;
        this[sName].push(iValue);
      }
      iTotalSize += iTypeSize * iArrayLength;
    }
  }
  if (iTotalSize % 2) throw new Error('Structures cannot have an odd size: add one byte padding to make it even.');
  this.toString = function () {
    var aiBytes = [];
    for (var iElementIndex = 0; iElementIndex < asElementNames.length; iElementIndex++) {
      var sName = asElementNames[iElementIndex];
      var iTypeSize = aiElementTypeSizes[iElementIndex];
      var iValueArrayLength = aiElementArrayLengths[iElementIndex];
      // If this is not an array, make it one so we can treat them the same:
      var aiValues = isNaN(iValueArrayLength) ? [this[sName]] : this[sName];
      if (isNaN(iValueArrayLength)) iValueArrayLength = 1;
      for (var iValueIndex = 0; iValueIndex < iValueArrayLength; iValueIndex++) {
        var iValue = aiValues[iValueIndex];
        for (var iByte = 0; iByte < iTypeSize; iByte++) {
          var iByteValue = (iValue >> (8 * iByte)) & 0xFF;
          aiBytes.push(iByteValue);
        }
      }
    }
    if (aiBytes.length != iTotalSize) 
        throw new Error('Sanity check failed: ' + aiBytes.length + ' != ' + iTotalSize + '!?');
    var uResult = "";
    for (var iByteIndex = 0; iByteIndex < aiBytes.length; iByteIndex += 2) {
      var iWord = aiBytes[iByteIndex] + aiBytes[iByteIndex + 1] * 0x100;
      uResult += String.fromCharCode(iWord);
    }
    return uResult;
  }
}