/*SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
                                                                                                                        
   ,dSSSSSSSSSSSS  SSSS    ,dSSY'  SSSS      SSSS  SSSS          SSSS  SSSSb,    SSSS  ,dSSSSSSSSSSSS  SSSSSSSSSSSSb,   
   SSSS            SSSS  ,dSSY'    SSSS      SSSS  SSSS          SSSS  SSSSSSb,  SSSS  SSSS            SSSS      SSSS   
   'YSSSSSSSSSSb,  SSSSSSSSSSSSb,  'YSSSSSSSSSSSS  SSSS          SSSS  SSSS'YSSb,SSSS  SSSSSSSSSSS     SSSS      SSSS   
             SSSS  SSSS      SSSS            SSSS  SSSS          SSSS  SSSS  'YSSSSSS  SSSS            SSSS      SSSS   
   SSSSSSSSSSSSP'  SSSS      SSSS  SSSSSSSSSSSSP'  'YSSSSSSSSSS  SSSS  SSSS    'YSSSS  'YSSSSSSSSSSSS  SSSS  SSSSSSP'   
                                                                                                                        
SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
                                                                                                                        
 This file contains information about various version of modules for Windows (ntdll.dll, kernel32.dll) and Microsoft    
 Internet Explorer (iexplore.exe, mshtml.dll, jscript.dll) that can be useful in exploits for vulnerabilities in MSIE   
 and plugins running in MSIE. Most of the information was collected automatically and has not been checked for accuracy.
                                                                                                                        
 Copyright (c) 2010 Berend-Jan "SkyLined" Wever <berendjanwever@gmail.com>                                              
 All rights reserved. This information is provided for academic purpose only.                                           
                                                                                                                        
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the       
 following conditions are met:                                                                                          
    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following  
      disclaimer.                                                                                                       
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the         
      following disclaimer in the documentation and/or other materials provided with the distribution.                  
    * Neither the name of the copyright holder nor the names of the contributors may be used to endorse or promote      
      products derived from this software without specific prior written permission.                                    
                                                                                                                        
 THIS SOFTWARE IS PROVIDED ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED  
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT     
 HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES    
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR         
 BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE         
 POSSIBILITY OF SUCH DAMAGE.                                                                                            
                                                                                                                        
SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS*/

var gaoModuleInfos = [];
function getPlatformInfo() {
  // Figure out what version of windows we are running in:
  var sWindowsVersion  = navigator.userAgent.match(/Windows NT (\d+.\d+)/)[1];
  var sWindowsLanguage = (navigator.systemLanguage ||
      navigator.userAgent.match(/Windows NT \d+.\d+; (\w+\-\w+)[;\)]/)[1]).toLowerCase();
  var bWOW64 = /Windows NT \d+.\d+; WOW64[;\)]/.test(navigator.userAgent);
  var sWindowsCpuClass = bWOW64 ? "x64" : (navigator.platform == "Win32" ? "x86" : "x64");
  var sModuleSubSystemCpuClass = bWOW64 ? 'WOW64' : sWindowsCpuClass;
  return {
    sWindowsVersion: sWindowsVersion,
    sWindowsLanguage: sWindowsLanguage,
    sWindowsCpuClass: sWindowsCpuClass,
    sModuleSubSystemCpuClass: sModuleSubSystemCpuClass
  }
}
function getBrowserModules() {
  var oPlatformInfo = getPlatformInfo();
  var aoBrowserModules = [];
  var oMSIEVersion = navigator.userAgent.match(/MSIE (\d+.\d+)/);
  if (oMSIEVersion) {
    // We know the build number for jscript, so our detection is more accurate. Therefore we shall get that first:
    var oJScriptRegExp = new RegExp(ScriptEngineMajorVersion() + "\\." + ScriptEngineMinorVersion() + 
        "\\.\\d+\\." + ScriptEngineBuildVersion());
    var aoModules = getModuleInfos(oPlatformInfo, {sModuleName: 'jscript.dll'});
    for (var i = 0; i < aoModules.length; i++) {
      if (oJScriptRegExp.test(aoModules[i].sModuleProductVersion)) {
        aoBrowserModules.push(aoModules[i]);
      }
    }
    var sMSIEVersion = oMSIEVersion[1];
    var aoModules = getModuleInfos(oPlatformInfo, {sModuleName: 'iexplore'});
    aoModules.concat(getModuleInfos(oPlatformInfo, {sModuleName: 'MSHTML'}));
    for (var i = 0; i < aoModules.length; i++) {
      if (aoModules[i].sModuleProductVersion.indexOf(sMSIEVersion) == 0) {
        aoBrowserModules.push(aoModules[i]);
      }
    }
  }
  return aoBrowserModules;
}

function getModuleInfos(/*oMatchValues, ...*/) {
  var aoMatchedModuleInfos = [];
  var oMatchValues = {};
  for (var i = 0; i < arguments.length; i++) {
    for (var sValueName in arguments[i]) {
      oMatchValues[sValueName] = arguments[i][sValueName];
    }
  }
  nextModule:
  for (var i = 0; i < gaoModuleInfos.length; i++) {
    var oModuleInfo = gaoModuleInfos[i];
    for (var sValueName in oMatchValues) {
      if (oModuleInfo[sValueName] != oMatchValues[sValueName]) {
        continue nextModule;
      }
    }
    aoMatchedModuleInfos.push(oModuleInfo);
  }
  return aoMatchedModuleInfos;
}

gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "ntdll.dll",
  sModuleFileVersion:                   "5.1.2600.5755 (xpsp_sp3_gdr.090206-1234)",
  sModuleProductVersion:                "5.1.2600.5755",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x49901D48,
  iModuleCheckSum:                      0x000BC674,
  iModuleImageBase:                     0x7C900000,
  dsiFunctionOffsets: {
      "ZwProtectVirtualMemory":         0x0000D6EE,
      "ZwSetInformationProcess":        0x0000DC9E},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0x18BFE, 0x5C2D9, 0x7CECC],
  aiXchgEaxEbpRetOffsets: [
      0x181BD, 0x35A11, 0x5C325],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x26D6C, 0x73048, 0x22124, 0x22745, 0x23D78, 0x5602B,
      0x56623, 0x56627, 0x72744, 0x72E70, 0x73122, 0xE449,
      0x12EB4, 0x18534, 0x19905, 0x1B070, 0x1B3AC, 0x1BC44,
      0x1C266, 0x1F3F5, 0x247EB, 0x249AC, 0x251BA, 0x25C11,
      0x29782, 0x2D6F2, 0x2FBE2, 0x33CAC, 0x34607, 0x3470B,
      0x34DBA, 0x374F5, 0x37985, 0x38110, 0x384C3, 0x39748,
      0x399C0, 0x3F32A, 0x50E27, 0x50E34, 0x51102, 0x51C0F,
      0x51D6F, 0x52CBB, 0x59EAB, 0x624D1, 0x632B3, 0x69F00,
      0x6A7F1, 0x6D7B6, 0x70734, 0x71961, 0x71AA9, 0x71BD8,
      0x71CBB, 0x71D88, 0x71E2F, 0x71FE3, 0x72093, 0x721AA,
      0x72216, 0x7221B, 0x7221F, 0x72388, 0x7261E, 0x72C0C,
      0x72CF6, 0x72D1C, 0x72F95, 0x72FAA, 0x72FC0, 0x72FEB,
      0x73F9F, 0x740F8, 0x748EC, 0x7519F, 0x75BEA, 0x76D83,
      0x779E3, 0x779EF, 0x779F4, 0x7B92A]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows Vista Pro Service Pack 2 en-us (build 6002)",
  sWindowsVersion:                      "6.0",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "ntdll.dll",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "6.0.6001.18000 (longhorn_rtm.080118-1840)",
  sModuleProductVersion:                "6.0.6001.18000",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x49E03821,
  iModuleCheckSum:                      0x0012C163,
  iModuleImageBase:                     0x77ED0000,
  dsiFunctionOffsets: {
      "ZwProtectVirtualMemory":         0x00064D34,
      "ZwSetInformationProcess":        0x00065324},
  aiBreakRetOffsets: [
      0x48B2E, 0x7B7B3, 0xBFD6B, 0xC014F, 0xC0160, 0xC0551,
      0xC055F],
  aiPopEaxRetOffsets: [],
  aiXchgEaxEbxRetOffsets: [
      0x2EF8C],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [
      0x23C59],
  aiXchgEaxEspRetOffsets: [
      0x1F248, 0x83B92, 0x8E7A4, 0x98362, 0xA74F0, 0xAB24C],
  aiXchgEaxEbpRetOffsets: [
      0x46061, 0x983AE, 0x9C6CE],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [
      0x4DF4],
  aiLeaveRetOffsets: [
      0x7943, 0x14361, 0x3536E, 0x3586A, 0x36D76, 0x7744F,
      0xA4A55, 0xA5672, 0xB5752, 0xB5A59, 0xB6169, 0xB6836,
      0xB6A46, 0xB6B38, 0xB7267, 0xB7A48, 0x7C2D, 0x17B35,
      0x3482D, 0x45C71, 0x66526, 0xB3224, 0xB4D60, 0xB5B2F,
      0xB655E, 0xB6B5E, 0xB6E26, 0xB6F5B, 0xB713B, 0xB7140,
      0xB723C, 0x799A, 0x7AA7, 0x7AE0, 0xD2EB, 0xD602,
      0x10292, 0x1042A, 0x16E8E, 0x1B364, 0x1B556, 0x1BFDF,
      0x1C9DA, 0x22983, 0x250DE, 0x263A5, 0x277F4, 0x2CEC3,
      0x2D04C, 0x2D152, 0x2D35A, 0x2D46C, 0x2DBAF, 0x2ECA3,
      0x3180F, 0x322A1, 0x33512, 0x350D4, 0x35C0C, 0x3CA92,
      0x42411, 0x424F6, 0x425F6, 0x44588, 0x44611, 0x45BC2,
      0x45F80, 0x468E8, 0x48A8B, 0x49265, 0x49881, 0x4988D,
      0x4989F, 0x498B9, 0x49A1D, 0x49A2B, 0x49A41, 0x49A5B,
      0x49BC1, 0x49BCD, 0x49BDF, 0x49BF9, 0x49D5D, 0x49D6B,
      0x49D81, 0x49D9B, 0x4A002, 0x4A34D, 0x4A38B, 0x4A3E2,
      0x65CF1, 0x6649A, 0x667D1, 0x6BCD0, 0x6BDDF, 0x6CC6B
      /*...62 not shown...*/]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "ntdll.dll",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "6.1.7600.16385 (win7_rtm.090713-1255)",
  sModuleProductVersion:                "6.1.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "WOW64",
  iModuleTimeDateStamp:                 0x4BA9B29C,
  iModuleCheckSum:                      0x0013EDC5,
  iModuleImageBase:                     0x7DE70000,
  dsiFunctionOffsets: {
      "ZwProtectVirtualMemory":         0x0001FFC8,
      "ZwSetInformationProcess":        0x0001FAB8},
  aiBreakRetOffsets: [
      0x8C0AC],
  aiPopEaxRetOffsets: [
      0x50BEA, 0x8C1BD],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0xC7236, 0x6EB10, 0x93DB3, 0xA1DF7, 0xCA873],
  aiXchgEaxEbpRetOffsets: [
      0xB6F2E, 0x74CDE, 0xB0C8C, 0xB0CC9, 0xDD082],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x46462, 0x4786B, 0x5526E, 0x56755, 0x57148, 0x93041,
      0xB7175, 0xC5277, 0xD3844, 0xD4556, 0xD4F52, 0xD4F57,
      0x43D6F, 0x4652B, 0x4795E, 0x52259, 0x56D23, 0x92E6E,
      0xA5B69, 0xC2F26, 0xC4324, 0xD3E3F, 0xD4038, 0xD4A7B,
      0xD4F5B, 0xD5E6E, 0xD6047, 0xD6121, 0x41EDE, 0x467C2,
      0x46D97, 0x46F0F, 0x475D1, 0x477F0, 0x478EC, 0x4A392,
      0x4A528, 0x4A607, 0x4C94E, 0x4DD87, 0x5043B, 0x507E4,
      0x50FDE, 0x521F2, 0x53E1C, 0x54FFA, 0x551BE, 0x56601,
      0x5A095, 0x5BFD1, 0x5C8EE, 0x5CC62, 0x5DB8E, 0x5F7F1,
      0x65283, 0x68F7B, 0x69901, 0x70BA9, 0x70BFE, 0x71F62,
      0x71FFF, 0x748C3, 0x7BC95, 0x7C2C2, 0x7C4DD, 0x7C52B,
      0x7C582, 0x7C8C1, 0x7CB11, 0x7CD98, 0x800BF, 0x8F924,
      0x925C8, 0x9AAD6, 0x9F43E, 0x9FD30, 0xA5FE1, 0xA61B2,
      0xA7DA9, 0xA7DAD, 0xA8434, 0xA8670, 0xA86F7, 0xA8D3F,
      0xA8F61, 0xA9225, 0xAADE1, 0xAC5CA, 0xAC6B8, 0xB7CF5,
      0xB9EEF, 0xBEB14, 0xBED25, 0xC16B3, 0xC2DD2, 0xC49BE
      /*...54 not shown...*/]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "ntdll.dll",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "6.1.7600.16385 (win7_rtm.090713-1255)",
  sModuleProductVersion:                "6.1.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x64",
  iModuleTimeDateStamp:                 0x4BA9B802,
  iModuleCheckSum:                      0x001B7506,
  iModuleImageBase:                     0x78E50000,
  dsiFunctionOffsets: {
      "ZwProtectVirtualMemory":         0x00050250,
      "ZwSetInformationProcess":        0x0004FF10},
  aiBreakRetOffsets: [
      0x4EF90, 0x4EFA0, 0x4EFB0, 0x4EFD0, 0x4EFF3, 0x4F001,
      0xA9837],
  aiPopEaxRetOffsets: [
      0x3684E, 0xE5148, 0xD3826, 0xD7D56, 0x40E1, 0x55BA,
      0x7EA2, 0x960A, 0xF532, 0x1CE0F, 0x1DB0A, 0x201BA,
      0x2E3FD, 0x3DAAC, 0x41029, 0x420BE, 0x432E6, 0x456A4,
      0x4E1B2, 0x661E0, 0x795A4, 0x795AE, 0x795B8, 0x79BFB,
      0x7C756, 0x884E6, 0x8A32A, 0x8ACBD, 0x8AFF0, 0x8B006,
      0x8B2A8, 0x992A8, 0xA13F8, 0xA1633, 0xA47B4, 0xA6414,
      0xA6EB8, 0xA80B1, 0xB1D85, 0xB1E57, 0xB1E97, 0xB1ED3,
      0xB1F13, 0xBB972, 0xC18AE, 0xD7D9C, 0xE5197, 0xE7095,
      0xEF18B],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [
      0x65E38],
  aiXchgEaxEspRetOffsets: [
      0xF216B, 0xA1C82, 0xA1CF1, 0xE83B3, 0xF1ABA],
  aiXchgEaxEbpRetOffsets: [
      0x415E, 0x182C3, 0x8BA3C, 0xB9213, 0xB998B, 0xB9B1B,
      0xDEF17, 0xE96DD, 0xF0694],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [
      0x7369A],
  aiLeaveRetOffsets: []
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "kernel32",
  sModuleFileVersion:                   "5.1.2600.5781 (xpsp_sp3_gdr.090321-1317)",
  sModuleProductVersion:                "5.1.2600.5781",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x49C4F482,
  iModuleCheckSum:                      0x000FE572,
  iModuleImageBase:                     0x7C800000,
  dsiFunctionOffsets: {
      "VirtualProtect":                 0x00001AD4},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [
      0x998D, 0x7F325, 0x7F423, 0x7FBC0, 0x7FE20],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [
      0x7C7D1],
  aiXchgEaxEspRetOffsets: [],
  aiXchgEaxEbpRetOffsets: [
      0xB0FB],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x1312C, 0x17322, 0x17626, 0x37C7C, 0x43D7B, 0x7527C,
      0x9412, 0xA01A, 0xA619, 0xAD17, 0xAD1C, 0xD290,
      0xF30B, 0x150E0, 0x151B9, 0x179F7, 0x17C96, 0x17FAA,
      0x18324, 0x18B65, 0x1AD24, 0x1AF21, 0x1CD24, 0x1DAFB,
      0x2A741, 0x2B54C, 0x2B958, 0x2C001, 0x2CBFE, 0x2E495,
      0x2F441, 0x30B4B, 0x31DE4, 0x333CC, 0x39D94, 0x3AFCA,
      0x3C85C, 0x44D9E, 0x48419, 0x5AD38, 0x5EA8B, 0x61DDE,
      0x61DE7, 0x61DEB, 0x61DF0, 0x6B621, 0x6CD08, 0x6CEA8,
      0x70F03, 0x721C6, 0x754FE, 0x756A6, 0x7660C, 0x7B2FA,
      0x7DC8D, 0x7DEFF, 0x7E431, 0x7E792, 0x7EB47, 0x80CBE]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows Vista Pro Service Pack 2 en-us (build 6002)",
  sWindowsVersion:                      "6.0",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "kernel32",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "6.0.6001.18000 (longhorn_rtm.080118-1840)",
  sModuleProductVersion:                "6.0.6001.18000",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x49E037DD,
  iModuleCheckSum:                      0x000DBE01,
  iModuleImageBase:                     0x77DF0000,
  dsiFunctionOffsets: {
      "VirtualProtect":                 0x00001DC3},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [
      0x4C0C0, 0x4D008, 0xB9744, 0xB9945, 0xBAD19, 0xBB543,
      0xBB88E, 0xBBF45],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0x74242, 0x72601, 0x726A6, 0x87A1C],
  aiXchgEaxEbpRetOffsets: [
      0x28EB6, 0xB895F],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x46F58, 0x4736C, 0x95569, 0x9556E, 0x95572, 0x95577,
      0x2207C, 0x2385C, 0x72B35, 0x86F40, 0xEB4F, 0x102F9,
      0x1A241, 0x1B1FD, 0x1C560, 0x1D985, 0x1E3EE, 0x1EE6D,
      0x1EE71, 0x20B38, 0x20BC1, 0x20DAA, 0x21D27, 0x266DF,
      0x26AE2, 0x28B17, 0x2A605, 0x2A7EE, 0x2B346, 0x2B625,
      0x2B6ED, 0x2C072, 0x2D7E5, 0x2DF76, 0x2E8E5, 0x3EA71,
      0x405C0, 0x40741, 0x46FB6, 0x47E0C, 0x49F34, 0x4D370,
      0x4E984, 0x55BBC, 0x579E3, 0x588D6, 0x5A4BA, 0x670DB,
      0x72D97, 0x73CFB, 0x750CA, 0x8C5D9, 0x8F7F2, 0x96AF4,
      0x9DFA5, 0x9F38B, 0x9FD4A, 0x9FD7E, 0x9FD82, 0xA5AD8,
      0xA6DAA, 0xA932C, 0xAB236, 0xB03A3, 0xB0A48, 0xB8D2D,
      0xB8F16, 0xBE645, 0xC0361, 0xC09E3, 0xC0AA9]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "kernel32",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "6.1.7600.16385 (win7_rtm.090713-1255)",
  sModuleProductVersion:                "6.1.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "WOW64",
  iModuleTimeDateStamp:                 0x4A5BDBDE,
  iModuleCheckSum:                      0x000D900E,
  iModuleImageBase:                     0x7DD60000,
  dsiFunctionOffsets: {
      "VirtualProtect":                 0x000134EC},
  aiBreakRetOffsets: [
      0x6B318],
  aiPopEaxRetOffsets: [
      0xB246B, 0x6B338, 0xAEF9F, 0xAF1A9, 0xB0806, 0xB0A0F,
      0xB0B54, 0xB118A, 0xB1469],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0x48B1B, 0x48BF3, 0x910CC, 0xB9F15],
  aiXchgEaxEbpRetOffsets: [],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x9314E, 0x9316D, 0x93023, 0x9312B, 0x95322, 0xB3E37,
      0x4E3B8, 0x50211, 0x854C1, 0x8AFA5, 0x8DE40, 0x93015,
      0x9301A, 0x9301E, 0x93190, 0x94FBD, 0x9C818, 0x9DE88,
      0x9E06C, 0x9E9B9, 0x9EA37, 0xA3EBC, 0xABC13, 0xB68C3,
      0xBA0FC, 0xBC0A1, 0xBD484, 0xBDEF8, 0xBDF24, 0xBE3E6,
      0xBE4E1, 0xBE54B, 0xBFBEC]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "kernel32",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "6.1.7600.16385 (win7_rtm.090713-1255)",
  sModuleProductVersion:                "6.1.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x64",
  iModuleTimeDateStamp:                 0x4A5BDFDF,
  iModuleCheckSum:                      0x00128DD7,
  iModuleImageBase:                     0x78D20000,
  dsiFunctionOffsets: {
      "VirtualProtect":                 0x00004410},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [
      0x8613A, 0xEC13, 0x32CD9, 0x32CE3, 0x48074, 0x4BC7A,
      0x4BE46, 0x4BEEA, 0x50A06, 0x6D252, 0x85DCE, 0x8E5CA],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [
      0x40903],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0x36CF8, 0x36DC3, 0x36F01, 0x40362, 0x403F2, 0x546B7,
      0x68C80, 0x694B7, 0x6CEFF, 0x828C9, 0x83DDA, 0x95EB1],
  aiXchgEaxEbpRetOffsets: [
      0x4B3AF, 0x51278, 0x58D93, 0x60D2E],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x70853]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "iexplore",
  sModuleFileVersion:                   "6.00.2900.5512 (xpsp.080413-2105)",
  sModuleProductVersion:                "6.00.2900.5512",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x48025225,
  iModuleCheckSum:                      0x00017A61,
  iModuleImageBase:                     0x00400000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [
      0x57C4],
  aiPopEaxRetOffsets: [],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [],
  aiXchgEaxEbpRetOffsets: [],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: []
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "iexplore",
  sModuleFileVersion:                   "7.00.6000.17080 (vista_gdr.100616-0452)",
  sModuleProductVersion:                "7.00.6000.17080",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x4C18DC4A,
  iModuleCheckSum:                      0x000A9B73,
  iModuleImageBase:                     0x00400000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [],
  aiXchgEaxEbpRetOffsets: [
      0xBF4A],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x4BDE, 0x4DB2, 0x909C, 0x91C1, 0x98DD, 0xA182,
      0xA2BF, 0xA760, 0xA93B, 0xAA36, 0xAC9D, 0xC74E,
      0xCA56]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "iexplore",
  sModuleFileVersion:                   "8.00.6001.18702 (longhorn_ie8_rtm(wmbla).090308-0339)",
  sModuleProductVersion:                "8.00.6001.18702",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x49B3AD2E,
  iModuleCheckSum:                      0x000A0294,
  iModuleImageBase:                     0x00400000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [],
  aiXchgEaxEbpRetOffsets: [],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x6C4A, 0x6F73, 0x7C55, 0x7717, 0x78F3, 0x79EE,
      0x8CE4, 0x8D65, 0x9157, 0x9DB9]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows Vista Pro Service Pack 2 en-us (build 6002)",
  sWindowsVersion:                      "6.0",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "iexplore",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "8.00.6001.18702 (longhorn_ie8_rtm(wmbla).090308-0339)",
  sModuleProductVersion:                "8.00.6001.18702",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x4C25813D,
  iModuleCheckSum:                      0x000A4425,
  iModuleImageBase:                     0x00400000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [],
  aiXchgEaxEbpRetOffsets: [],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x652B, 0x6D3F, 0x727D, 0x6202, 0x6F1B, 0x7016,
      0x830C, 0x838D, 0x889B, 0x90B7, 0x9AE4]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "iexplore",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "8.00.7600.16385 (win7_rtm.090713-1255)",
  sModuleProductVersion:                "8.00.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "WOW64",
  iModuleTimeDateStamp:                 0x4A5BC69E,
  iModuleCheckSum:                      0x000B061A,
  iModuleImageBase:                     0x00400000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [
      0x7C2F],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [],
  aiXchgEaxEbpRetOffsets: [],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x6E43, 0x7795, 0x78A9, 0x7CF1, 0x7FED, 0x8062,
      0x811A, 0x8532, 0x9294, 0x9315, 0x9707, 0xA146]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "iexplore",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "8.00.7600.16385 (win7_rtm.090713-1255)",
  sModuleProductVersion:                "8.00.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x64",
  iModuleTimeDateStamp:                 0x4A5BCA42,
  iModuleCheckSum:                      0x000B0620,
  iModuleImageBase:                     0x00400000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [],
  aiXchgEaxEbpRetOffsets: [
      0x43A5, 0x4DA4],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: []
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "MSHTML",
  sModuleFileVersion:                   "6.00.2900.6003 (xpsp_sp3_gdr.100623-1635)",
  sModuleProductVersion:                "6.00.2900.6003",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x4C234B44,
  iModuleCheckSum:                      0x002F3087,
  iModuleImageBase:                     0x7DC30000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [
      0xB645C, 0xC659, 0xC7DD, 0xC9BD, 0xC9E9, 0xCA95,
      0xCCA1, 0xCCA9, 0xCCB1, 0xCCB9, 0xCCC1, 0xCCC9,
      0xCCD1, 0xCCD9, 0xCD25, 0xDFE9, 0xDFED, 0x299C9,
      0x299D1, 0x2BF09, 0x5DFEC, 0x171A25, 0x1B048E, 0x1B2FD2,
      0x24D130],
  aiPopEaxRetOffsets: [
      0x14139, 0x14369, 0x14379, 0x14469, 0x14A69, 0x14C39,
      0x14C79, 0x15359, 0x15469, 0x1574D, 0x1576D, 0x16541,
      0x16B41, 0x1746D, 0x24975, 0x24A55, 0x2574D, 0x2576D,
      0x26131, 0x26171, 0x26A6D, 0x4354D, 0x64365, 0x66949,
      0x66959, 0x66979, 0x66A49, 0x66C6D, 0x1264D, 0x1274D,
      0x14049, 0x14079, 0x14A29, 0x1575D, 0x1583D, 0x16521,
      0x1767D, 0x24031, 0x24041, 0x24121, 0x25C29, 0x25D29,
      0x26021, 0x26031, 0x2692D, 0x26A3D, 0x42079, 0x42455,
      0x42465, 0x42625, 0x42B49, 0x42D51, 0x42E51, 0x4353D,
      0x4355D, 0x4365D, 0x47E61, 0x64325, 0x64425, 0x66C2D,
      0x66C3D, 0x66C5D, 0x66C7D, 0x66D3D, 0x67C3D, 0x67C4D,
      0x67C6D, 0x67C7D, 0x67D3D, 0xA5D75, 0x182022, 0x182026,
      0x18202A, 0x18202E, 0x182032, 0x182036, 0x18203A, 0x18203E,
      0x182042, 0x182046, 0x18204A, 0x18204E, 0x182052, 0x182056,
      0x18205A, 0x18205E, 0x182062, 0x182066, 0x18206A, 0x18206E,
      0x182072, 0x182076, 0x18207A, 0x18207E, 0x182122, 0x182126
      /*...484 not shown...*/],
  aiXchgEaxEbxRetOffsets: [
      0x286A49, 0x1613D, 0x44069, 0x4406D, 0x52A51, 0xE3C24,
      0x600D, 0x92E5, 0x9325, 0x9361, 0x93B1, 0xE095,
      0xE099, 0x1DF39, 0x1DF3D, 0x1F57D, 0x1F969, 0x1F96D,
      0x1F999, 0x1F99D, 0x21FE9, 0x21FED, 0x22019, 0x2201D,
      0x22CA1, 0x22CA5, 0x22CD1, 0x22CD5, 0x264DD, 0x264E1,
      0x3BB8D, 0x3BB91, 0x3E201, 0x3E205, 0x3E231, 0x3E235,
      0x40189, 0x4018D, 0x401B9, 0x401BD, 0x40539, 0x4053D,
      0x40569, 0x4056D, 0x43791, 0x43795, 0x44099, 0x4409D,
      0x446A5, 0x446A9, 0x44789, 0x4478D, 0x447B9, 0x447BD,
      0x49D1D, 0x49D21, 0x50FD5, 0x50FD9, 0x510C5, 0x510C9,
      0x51219, 0x5121D, 0x51249, 0x5124D, 0x525B1, 0x52BCD,
      0x645C4, 0x930EB, 0x9B59C, 0xB221B, 0x15C114, 0x165ADA,
      0x165B1C, 0x19F346, 0x1A0675, 0x26C5DA],
  aiXchgEaxEcxRetOffsets: [
      0x614D, 0x6175, 0xB334B, 0x10414B, 0x22021, 0x22025,
      0x22029, 0x2202D, 0x22031, 0x22035, 0x22065, 0x22069,
      0x22D21, 0x619D, 0x9115, 0x9159, 0x91A1, 0x1F9A1,
      0x1F9A5, 0x1F9A9, 0x1F9AD, 0x1F9B1, 0x1F9B5, 0x1F9E5,
      0x1F9E9, 0x22CD9, 0x22CDD, 0x22CE1, 0x22CE5, 0x22CE9,
      0x22CED, 0x22D1D, 0x3E239, 0x3E23D, 0x3E241, 0x3E245,
      0x3E249, 0x3E24D, 0x3E27D, 0x3E281, 0x401C1, 0x401C5,
      0x401C9, 0x401CD, 0x401D1, 0x401D5, 0x40205, 0x40209,
      0x40571, 0x40575, 0x40579, 0x4057D, 0x40581, 0x40585,
      0x405B5, 0x405B9, 0x440A1, 0x440A5, 0x440A9, 0x440AD,
      0x440B1, 0x440B5, 0x440E5, 0x440E9, 0x447C1, 0x447C5,
      0x447C9, 0x447CD, 0x447D1, 0x447D5, 0x44805, 0x44809,
      0x51251, 0x51255, 0x51259, 0x5125D, 0x51261, 0x51265,
      0x51295, 0x51299, 0x5A81C, 0xF07B0, 0xF8832, 0x101EDE,
      0x1BADA8, 0x1BAE47, 0x1BAE56],
  aiXchgEaxEdxRetOffsets: [
      0x6265, 0x14741, 0x26731, 0x26735, 0x44765, 0x44769,
      0x44771, 0x44775, 0x44779, 0x14721, 0x14725, 0x14729,
      0x1472D, 0x1473D, 0x1604D, 0x16075, 0x22C7D, 0x26721,
      0x26725, 0x26729, 0x2672D, 0x44045, 0x44049, 0x44051,
      0x44055, 0x44059, 0x4405D, 0x44061, 0x44065, 0x4477D,
      0x91E5, 0x922D, 0x9275, 0x92AD, 0x14719, 0x1471D,
      0x1F945, 0x1F949, 0x1F951, 0x1F955, 0x1F959, 0x1F95D,
      0x1F961, 0x1F965, 0x21FC5, 0x21FC9, 0x21FD1, 0x21FD5,
      0x21FD9, 0x21FDD, 0x21FE1, 0x21FE5, 0x22C81, 0x22C89,
      0x22C8D, 0x22C91, 0x22C95, 0x22C99, 0x22C9D, 0x3BFAD,
      0x3BFB1, 0x3E1DD, 0x3E1E1, 0x3E1E9, 0x3E1ED, 0x3E1F1,
      0x3E1F5, 0x3E1F9, 0x3E1FD, 0x40165, 0x40169, 0x40171,
      0x40175, 0x40179, 0x4017D, 0x40181, 0x40185, 0x40515,
      0x40519, 0x40521, 0x40525, 0x40529, 0x4052D, 0x40531,
      0x40535, 0x44781, 0x44785, 0x49CF9, 0x49CFD, 0x49D05,
      0x49D09, 0x49D0D, 0x49D11, 0x49D15, 0x49D19, 0x50FB1
      /*...33 not shown...*/],
  aiXchgEaxEspRetOffsets: [
      0x183261, 0x23537C, 0x9405, 0x944D, 0x9495, 0x4379D,
      0x437A1, 0x437E5, 0x437E9, 0x437ED, 0x437F1, 0x437F5,
      0x437F9, 0x5C2DC, 0x89DEF, 0x8A6A5, 0x8BB31, 0xDB794,
      0xF411E, 0xFF7ED, 0x103EC1, 0x104086, 0x138A57, 0x1454FA,
      0x16341B, 0x1831BC, 0x183210, 0x1CBBB8, 0x1D8641, 0x1E2388,
      0x1EA6FB, 0x209C2A, 0x2221F4, 0x235293, 0x270FDE],
  aiXchgEaxEbpRetOffsets: [
      0x6355, 0x43931, 0x294B39, 0x637D, 0x43925, 0x43929,
      0x4392D, 0x82062, 0x104046, 0x104063, 0x63A5, 0x63CD,
      0x94DD, 0x951D, 0x9565, 0x95A5, 0xC66D, 0xC695,
      0xF51D, 0xF545, 0x137ED, 0x16605, 0x16DC5, 0x16DED,
      0x176A5, 0x1C6A5, 0x1F2A9, 0x2FB35, 0x3F7B5, 0x437FD,
      0x43801, 0x6A868, 0x6C346, 0x784CA, 0x83999, 0x8A35B,
      0x8A79A, 0x9819D, 0xA0690, 0xAB73D, 0xAB943, 0xCCEBE,
      0xCDB13, 0xCF12D, 0x1040C2, 0x1323A9, 0x15F2F6, 0x18F103,
      0x1CBE8F, 0x1D5D14, 0x2115E3, 0x211708, 0x239874, 0x2412A0,
      0x2446DF, 0x2544B8],
  aiXchgEaxEsiRetOffsets: [
      0x1414D, 0x16665, 0x16751, 0x16759, 0x16761, 0x16769,
      0x16E49, 0x17155, 0x1D6D6A, 0x12845, 0x1662D, 0x1712D,
      0x42B5D, 0x4372D, 0x54041, 0x54075, 0x57D65, 0x63B29,
      0xE3D73, 0xE4840, 0x1D747B, 0x9741, 0x9749, 0x9751,
      0x9769, 0x9779, 0x9781, 0xC6BD, 0xC6F1, 0xC725,
      0xCCE1, 0xDCA5, 0xDCCD, 0xDCF5, 0xDD1D, 0xE0F1,
      0xEEB9, 0xEEC1, 0xEED1, 0xFC19, 0xFC21, 0xFC29,
      0x11D5D, 0x11E75, 0x11EAD, 0x11EE1, 0x16789, 0x16791,
      0x16799, 0x167A1, 0x167CD, 0x167F5, 0x1681D, 0x16E15,
      0x16EB1, 0x176CD, 0x177A1, 0x178F5, 0x1C705, 0x1DCA5,
      0x1DCD9, 0x1DDC5, 0x1DF65, 0x211B1, 0x21409, 0x234B5,
      0x234F1, 0x29869, 0x29871, 0x29879, 0x29899, 0x298A1,
      0x298C9, 0x298D1, 0x298D9, 0x29949, 0x29969, 0x29981,
      0x29989, 0x29991, 0x2B111, 0x2B809, 0x2B9F1, 0x2BA19,
      0x2BA21, 0x2BBE1, 0x2BC21, 0x2BCF9, 0x2BD01, 0x2BEA1,
      0x2BEA9, 0x2BEB1, 0x2BF49, 0x2BF91, 0x2C101, 0x2CE41
      /*...69 not shown...*/],
  aiXchgEaxEdiRetOffsets: [
      0x1286D, 0x45525, 0x9759, 0x9761, 0x9771, 0xC74D,
      0x1DF8D, 0x354C2, 0x3954D, 0x42B85, 0x42EFD, 0x4A5CD,
      0xB926D, 0x123008],
  aiLeaveRetOffsets: [
      0x73879, 0x76D52, 0x83053, 0x86F6F, 0x9316A, 0x93847,
      0x9384B, 0x95644, 0x95777, 0x97558, 0xA3043, 0xA3633,
      0xB646A, 0xC5A5A, 0xC6930, 0xD5761, 0xD5A62, 0xF6361,
      0xF7050, 0x144A77, 0x156E71, 0x163677, 0x163868, 0x166764,
      0x186655, 0x19496D, 0x1A5556, 0x1B4434, 0x1B4763, 0x1B484B,
      0x1B7946, 0x1C695A, 0x1C6974, 0x1C6E6A, 0x1E6646, 0x1E6758,
      0x1E6836, 0x227934, 0x236742, 0x243155, 0x243159, 0x243263,
      0x244642, 0x246276, 0x254478, 0x25646E, 0x256544, 0x264C46,
      0x26626D, 0x26796F, 0x274B56, 0x274B5A, 0x286431, 0x7735D,
      0x7783E, 0x8274E, 0x85F37, 0x92C2F, 0x9307E, 0x94C2D,
      0x9552D, 0x95D76, 0x95E7D, 0xA2725, 0xB2975, 0xB337C,
      0xC377C, 0xC4E20, 0xC5822, 0xC7A2A, 0xD2C6A, 0xD442E,
      0xD4F5E, 0xE2A4E, 0xE2A6F, 0xE2E27, 0xE7521, 0xF2943,
      0xF6560, 0x143121, 0x144A20, 0x154B7B, 0x156C5B, 0x163F4F,
      0x165C41, 0x18713A, 0x197A3E, 0x1B3A21, 0x1B3A65, 0x1B5D3D,
      0x1B5D5E, 0x1B5E24, 0x1B5E45, 0x1B5E66, 0x1B5F2E, 0x1B5F4F
      /*...784 not shown...*/]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "MSHTML",
  sModuleFileVersion:                   "7.00.6000.17080 (vista_gdr.100616-0452)",
  sModuleProductVersion:                "7.00.6000.17080",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x4C234C60,
  iModuleCheckSum:                      0x0036F645,
  iModuleImageBase:                     0x3CEA0000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [
      0x5E57B, 0xBA745],
  aiPopEaxRetOffsets: [
      0x2676A, 0x83942, 0x8394A, 0x8394E, 0x83952, 0x83956,
      0x8395A, 0x83962, 0x83966, 0x8396A, 0x8396E, 0x83972,
      0x83976, 0x8397A, 0xE594A, 0x113347, 0x11374F, 0x2F5547,
      0x8395E, 0x8397E, 0x83A22, 0x83A26, 0x83A2A, 0x83A2E,
      0x83A32, 0x83A36, 0x83A3A, 0x83A3E, 0x83A42, 0x83A46,
      0x83A4A, 0x83A4E, 0x83A52, 0x83A56, 0x83A5A, 0x83A5E,
      0x83A62, 0x83A66, 0x83A6A, 0x83A6E, 0x83A72, 0x83A76,
      0x83A7A, 0x83A7E, 0x206B22, 0x2B2725, 0x883B, 0x954E,
      0x2C600, 0x4AA4F, 0x79CC0, 0x81204, 0x83982, 0x83986,
      0x8398A, 0x8398E, 0x83992, 0x83996, 0x8399A, 0x8399E,
      0x839A2, 0x839A6, 0x839AA, 0x839AE, 0x839B2, 0x839B6,
      0x839BA, 0x839BE, 0x839C2, 0x839C6, 0x839CA, 0x839CE,
      0x839D2, 0x839D6, 0x839DA, 0x839DE, 0x839E2, 0x839E6,
      0x839EA, 0x839EE, 0x839F2, 0x839F6, 0x839FA, 0x839FE,
      0x83A02, 0x83A06, 0x83A0A, 0x83A0E, 0x83A12, 0x83A16,
      0x83A1A, 0x83A1E, 0x83A82, 0x83A86, 0x83A8A, 0x83A8E
      /*...50 not shown...*/],
  aiXchgEaxEbxRetOffsets: [
      0xA1A67],
  aiXchgEaxEcxRetOffsets: [
      0xA1A72, 0xCE07D, 0xE1E88, 0x17141F],
  aiXchgEaxEdxRetOffsets: [
      0x87401, 0xEA000, 0x1858F0],
  aiXchgEaxEspRetOffsets: [
      0xB5735, 0x136D30, 0x2B694D, 0x2B6A3B, 0x2C75E, 0x40C7E,
      0x7D501, 0x832CB, 0x90CBE, 0x92ABE, 0x108268, 0x12AC72,
      0x156F84, 0x19B8AA, 0x1DCEF6, 0x1E9345, 0x2178D7, 0x22E541,
      0x22E593, 0x27F25D, 0x2846C0, 0x2A95A7, 0x2DB8E8, 0x2E9B25],
  aiXchgEaxEbpRetOffsets: [
      0x36A37, 0xE314A, 0x65D4E, 0x3C56B, 0x4B0F1, 0x4BA12,
      0x4D27C, 0x713DE, 0x713EE, 0x7141C, 0x7142C, 0x71448,
      0x749ED, 0x81C7D, 0x89EEC, 0x8E5A7, 0x90CA8, 0xA0ED3,
      0xA591F, 0xEA565, 0xF8B39, 0x108284, 0x11B597, 0x12DF9F,
      0x18E242, 0x1B1DB0, 0x1B4492, 0x1EAE03, 0x25608A, 0x26261A,
      0x290036, 0x2A04D2, 0x2A05FF, 0x2C9416, 0x2FBB3F, 0x2FBB7D],
  aiXchgEaxEsiRetOffsets: [
      0x271E83, 0x2DADA0],
  aiXchgEaxEdiRetOffsets: [
      0x188DFA, 0x1AB9AB],
  aiLeaveRetOffsets: [
      0x7763, 0x14774, 0x14C58, 0x16172, 0x26A41, 0x36E45,
      0x57573, 0x7516F, 0x77551, 0xA3577, 0xA5A59, 0xA714A,
      0xA7232, 0x143766, 0x14576B, 0x164335, 0x165878, 0x167858,
      0x183078, 0x184732, 0x186753, 0x206F32, 0x21515A, 0x25474A,
      0x25567A, 0x256270, 0x26487A, 0x296646, 0x296E44, 0x297335,
      0x2C6B69, 0x2C6F61, 0x2C7564, 0x2D4E59, 0x2D5751, 0x2D6730,
      0x2D684B, 0x2E7362, 0x6321, 0x687C, 0x13A55, 0x1525D,
      0x17E70, 0x26050, 0x2712D, 0x35D55, 0x37E37, 0x52756,
      0x52E55, 0x52F2E, 0x52F78, 0x5317D, 0x75427, 0x8542B,
      0x93D60, 0x94428, 0x95B2A, 0xA3E6A, 0xA702C, 0xB2678,
      0xB6F40, 0xC3A47, 0xD605E, 0xF5A3C, 0xF5A60, 0xF7540,
      0x107C39, 0x117121, 0x122729, 0x125F64, 0x132E32, 0x142258,
      0x156127, 0x162878, 0x16723F, 0x18283D, 0x182D25, 0x18325D,
      0x185D65, 0x186078, 0x186A25, 0x187C38, 0x187D72, 0x192968,
      0x20213E, 0x213C6C, 0x217C75, 0x223F7C, 0x235920, 0x252723,
      0x252744, 0x25282D, 0x25284E, 0x25286F, 0x252937, 0x252958
      /*...834 not shown...*/]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows Vista Pro Service Pack 2 en-us (build 6002)",
  sWindowsVersion:                      "6.0",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "MSHTML",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "8.00.6001.18702 (longhorn_ie8_rtm(wmbla).090308-0339)",
  sModuleProductVersion:                "8.00.6001.18702",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x4C259878,
  iModuleCheckSum:                      0x005B357B,
  iModuleImageBase:                     0x74020000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [
      0x24F93E, 0x2772B8, 0x2DD960, 0x31C2FE, 0x49D72B, 0x49D7E9],
  aiPopEaxRetOffsets: [
      0x43731, 0x46536, 0x95947, 0x135944, 0x154B52, 0x314E37,
      0x314E43, 0x37344A, 0x37344E, 0x3B5033, 0x3B5037, 0x3B5055,
      0x3B5059, 0x453445, 0x453455, 0x10203D, 0x12565E, 0x132075,
      0x135940, 0x1C512A, 0x1C563A, 0x1C715C, 0x247E79, 0x314E3B,
      0x314E3F, 0x3A3E27, 0x423923, 0x423927, 0x4F5B31, 0x4F5B38,
      0x4EA8, 0x86C9, 0x9DCE, 0x24902, 0x251D8, 0x2C0C2,
      0x353E5, 0x3E2BB, 0x4909D, 0x4D8CD, 0x536F1, 0x68008,
      0x68010, 0x68014, 0x68018, 0x6801C, 0x68020, 0x68024,
      0x68028, 0x6802C, 0x68030, 0x68034, 0x68038, 0x6803C,
      0x68040, 0x68044, 0x68048, 0x6804C, 0x68050, 0x68054,
      0x68058, 0x6805C, 0x68060, 0x68064, 0x68068, 0x6806C,
      0x68070, 0x68074, 0x68078, 0x6807C, 0x68080, 0x68084,
      0x68088, 0x6808C, 0x68090, 0x68094, 0x68098, 0x6809C,
      0x680A0, 0x680A4, 0x680A8, 0x680AC, 0x680B0, 0x680B4,
      0x680B8, 0x680BC, 0x680C0, 0x680C4, 0x680C8, 0x680CC,
      0x680D0, 0x680D4, 0x680D8, 0x680DC, 0x680E0, 0x680E4
      /*...268 not shown...*/],
  aiXchgEaxEbxRetOffsets: [
      0x1135E5, 0x4494D7, 0x483486, 0x484296, 0x4BF902],
  aiXchgEaxEcxRetOffsets: [
      0x277320, 0xCF79C, 0xF5D03, 0x24C8AC, 0x40F6EE, 0x479426],
  aiXchgEaxEdxRetOffsets: [
      0x10C99, 0xEAF60, 0x4A0381],
  aiXchgEaxEspRetOffsets: [
      0x67378, 0x1D4A68, 0x1D4A6C, 0x205040, 0x2D7D60, 0x4A3E4D,
      0x4F2438, 0x4F2452, 0x2CFBE, 0x465B4, 0x536B1, 0x67CAD,
      0x6C380, 0xAA494, 0xBC142, 0xF5301, 0xF79C7, 0x11832F,
      0x13D1D9, 0x13D1F9, 0x1495D8, 0x150381, 0x16C78E, 0x17E1A5,
      0x181028, 0x18A367, 0x194102, 0x1D63E1, 0x22A6DD, 0x230DF3,
      0x27DD93, 0x28AA13, 0x32D8A0, 0x331AFE, 0x33C6F7, 0x33D079,
      0x33DF2F, 0x33DF7D, 0x3631AA, 0x3B5287, 0x3D1551, 0x3E16FE,
      0x3E1717, 0x3E172D, 0x3E17B6, 0x3E17CA, 0x3F940C, 0x3FFA1F,
      0x3FFB0F, 0x40D34E, 0x42CA33, 0x42CE63, 0x4303AB, 0x460897,
      0x47E8E4, 0x49D34B, 0x49FACA, 0x4C114F, 0x4D458C, 0x4F2404,
      0x4F241E, 0x4F24A0, 0x4F24BA, 0x4F24D4, 0x50BD76, 0x50BDA5,
      0x50F877, 0x5136B3],
  aiXchgEaxEbpRetOffsets: [
      0x19426A, 0x246C68, 0x42A30, 0x92E3F, 0x12445D, 0x142B50,
      0x25753D, 0x2C744, 0x2CFCD, 0x46BF5, 0x4F086, 0x4F096,
      0x4F0C4, 0x4F0D4, 0x4F0F0, 0x5B43F, 0x655A9, 0x6E4B3,
      0x89069, 0x90698, 0xA2B1F, 0xBA3AB, 0xC14A2, 0x1244CB,
      0x12F725, 0x1BAE28, 0x21B963, 0x230B32, 0x27581A, 0x2BF918,
      0x2CBDA4, 0x2E24BF, 0x2E24D6, 0x2E24ED, 0x2ED61A, 0x3487B2,
      0x3E70A9, 0x3F06C5, 0x4147DE, 0x45E169, 0x45E1A1, 0x4ABA0F,
      0x50CB4A, 0x512EDB, 0x512F19, 0x527F1E],
  aiXchgEaxEsiRetOffsets: [
      0x2CBA28],
  aiXchgEaxEdiRetOffsets: [
      0x18471C, 0x1C8B4A, 0x409C99, 0x478E11],
  aiLeaveRetOffsets: [
      0x14462, 0x15A44, 0x16A71, 0x34566, 0x35177, 0x4786B,
      0x53863, 0x55839, 0x56B44, 0x74577, 0x74F6D, 0x94473,
      0x9567A, 0xB4459, 0xB5231, 0xB7968, 0xC4641, 0xC4663,
      0xC494D, 0x116931, 0x134B61, 0x15446B, 0x167658, 0x177A72,
      0x1A7A4C, 0x1B4953, 0x1B4E30, 0x1C4851, 0x1C5353, 0x1D6A31,
      0x1D7242, 0x1D7268, 0x1E3330, 0x1E4463, 0x1E526F, 0x1F3649,
      0x1F4853, 0x216376, 0x23444F, 0x246F76, 0x27754D, 0x277A72,
      0x336369, 0x346D31, 0x354D39, 0x35794B, 0x364974, 0x397A4B,
      0x3A3076, 0x3A4148, 0x3A6147, 0x3B6379, 0x3D4F64, 0x3D794C,
      0x3E726A, 0x3F5869, 0x3F7733, 0x424B34, 0x426F73, 0x43566F,
      0x435673, 0x436864, 0x437773, 0x437848, 0x444E36, 0x444E5A,
      0x447166, 0x456161, 0x466359, 0x466673, 0x46764B, 0x47586F,
      0x476644, 0x486647, 0x493074, 0x495752, 0x496342, 0x4A775A,
      0x4A7A31, 0x514C73, 0x12B21, 0x1462F, 0x1602B, 0x16421,
      0x1702B, 0x3244F, 0x35C53, 0x4705D, 0x52E4D, 0x53925,
      0x53A22, 0x62773, 0x64C20, 0x67E78, 0x74440, 0x7463C
      /*...1418 not shown...*/]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "MSHTML",
  sModuleFileVersion:                   "8.00.6001.18939 (longhorn_ie8_gdr.100616-1700)",
  sModuleProductVersion:                "8.00.6001.18939",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x4C234DE8,
  iModuleCheckSum:                      0x005B4211,
  iModuleImageBase:                     0x3CEA0000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [
      0x24F93E, 0x2772B8, 0x2DD960, 0x31C2FE, 0x49D72B, 0x49D7E9],
  aiPopEaxRetOffsets: [
      0x43731, 0x46536, 0x95947, 0x135944, 0x154B52, 0x314E37,
      0x314E43, 0x37344A, 0x37344E, 0x3B5033, 0x3B5037, 0x3B5055,
      0x3B5059, 0x453445, 0x453455, 0x10203D, 0x12565E, 0x132075,
      0x135940, 0x1C512A, 0x1C563A, 0x1C715C, 0x247E79, 0x314E3B,
      0x314E3F, 0x3A3E27, 0x423923, 0x423927, 0x4F5B31, 0x4F5B38,
      0x4EA8, 0x86C9, 0x9DCE, 0x24902, 0x251D8, 0x2C0C2,
      0x353E5, 0x3E2BB, 0x4909D, 0x4D8CD, 0x536F1, 0x68008,
      0x68010, 0x68014, 0x68018, 0x6801C, 0x68020, 0x68024,
      0x68028, 0x6802C, 0x68030, 0x68034, 0x68038, 0x6803C,
      0x68040, 0x68044, 0x68048, 0x6804C, 0x68050, 0x68054,
      0x68058, 0x6805C, 0x68060, 0x68064, 0x68068, 0x6806C,
      0x68070, 0x68074, 0x68078, 0x6807C, 0x68080, 0x68084,
      0x68088, 0x6808C, 0x68090, 0x68094, 0x68098, 0x6809C,
      0x680A0, 0x680A4, 0x680A8, 0x680AC, 0x680B0, 0x680B4,
      0x680B8, 0x680BC, 0x680C0, 0x680C4, 0x680C8, 0x680CC,
      0x680D0, 0x680D4, 0x680D8, 0x680DC, 0x680E0, 0x680E4
      /*...268 not shown...*/],
  aiXchgEaxEbxRetOffsets: [
      0x1135E5, 0x4494D7, 0x483486, 0x484296, 0x4BF902],
  aiXchgEaxEcxRetOffsets: [
      0x277320, 0xCF79C, 0xF5D03, 0x24C8AC, 0x40F6EE, 0x479426],
  aiXchgEaxEdxRetOffsets: [
      0x10C99, 0xEAF60, 0x4A0381],
  aiXchgEaxEspRetOffsets: [
      0x67378, 0x1D4A68, 0x1D4A6C, 0x205040, 0x2D7D60, 0x4A3E4D,
      0x4F2438, 0x4F2452, 0x2CFBE, 0x465B4, 0x536B1, 0x67CAD,
      0x6C380, 0xAA494, 0xBC142, 0xF5301, 0xF79C7, 0x11832F,
      0x13D1D9, 0x13D1F9, 0x1495D8, 0x150381, 0x16C78E, 0x17E1A5,
      0x181028, 0x18A367, 0x194102, 0x1D63E1, 0x22A6DD, 0x230DF3,
      0x27DD93, 0x28AA13, 0x32D8A0, 0x331AFE, 0x33C6F7, 0x33D079,
      0x33DF2F, 0x33DF7D, 0x3631AA, 0x3B5287, 0x3D1551, 0x3E16FE,
      0x3E1717, 0x3E172D, 0x3E17B6, 0x3E17CA, 0x3F940C, 0x3FFA1F,
      0x3FFB0F, 0x40D34E, 0x42CA33, 0x42CE63, 0x4303AB, 0x460897,
      0x47E8E4, 0x49D34B, 0x49FACA, 0x4C114F, 0x4D458C, 0x4F2404,
      0x4F241E, 0x4F24A0, 0x4F24BA, 0x4F24D4, 0x50BD76, 0x50BDA5,
      0x50F877, 0x5136B3],
  aiXchgEaxEbpRetOffsets: [
      0x19426A, 0x246C68, 0x42A30, 0x92E3F, 0x12445D, 0x142B50,
      0x25753D, 0x2C744, 0x2CFCD, 0x46BF5, 0x4F086, 0x4F096,
      0x4F0C4, 0x4F0D4, 0x4F0F0, 0x5B43F, 0x655A9, 0x6E4B3,
      0x89069, 0x90698, 0xA2B1F, 0xBA3AB, 0xC14A2, 0x1244CB,
      0x12F725, 0x1BAE28, 0x21B963, 0x230B32, 0x27581A, 0x2BF918,
      0x2CBDA4, 0x2E24BF, 0x2E24D6, 0x2E24ED, 0x2ED61A, 0x3487B2,
      0x3E70A9, 0x3F06C5, 0x4147DE, 0x45E169, 0x45E1A1, 0x4ABA0F,
      0x50CB4A, 0x512EDB, 0x512F19, 0x527F1E],
  aiXchgEaxEsiRetOffsets: [
      0x2CBA28],
  aiXchgEaxEdiRetOffsets: [
      0x18471C, 0x1C8B4A, 0x409C99, 0x478E11],
  aiLeaveRetOffsets: [
      0x14462, 0x15A44, 0x16A71, 0x34566, 0x35177, 0x4786B,
      0x53863, 0x55839, 0x56B44, 0x74577, 0x74F6D, 0x94473,
      0x9567A, 0xB4459, 0xB5231, 0xB7968, 0xC4641, 0xC4663,
      0xC494D, 0x116931, 0x134B61, 0x15446B, 0x167658, 0x177A72,
      0x1A7A4C, 0x1B4953, 0x1B4E30, 0x1C4851, 0x1C5353, 0x1D6A31,
      0x1D7242, 0x1D7268, 0x1E3330, 0x1E4463, 0x1E526F, 0x1F3649,
      0x1F4853, 0x216376, 0x23444F, 0x246F76, 0x27754D, 0x277A72,
      0x336369, 0x346D31, 0x354D39, 0x35794B, 0x364974, 0x397A4B,
      0x3A3076, 0x3A4148, 0x3A6147, 0x3B6379, 0x3D4F64, 0x3D794C,
      0x3E726A, 0x3F5869, 0x3F7733, 0x424B34, 0x426F73, 0x43566F,
      0x435673, 0x436864, 0x437773, 0x437848, 0x444E36, 0x444E5A,
      0x447166, 0x456161, 0x466359, 0x466673, 0x46764B, 0x47586F,
      0x476644, 0x486647, 0x493074, 0x495752, 0x496342, 0x4A775A,
      0x4A7A31, 0x514C73, 0x12B21, 0x1462F, 0x1602B, 0x16421,
      0x1702B, 0x3244F, 0x35C53, 0x4705D, 0x52E4D, 0x53925,
      0x53A22, 0x62773, 0x64C20, 0x67E78, 0x74440, 0x7463C
      /*...1418 not shown...*/]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "MSHTML",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "8.00.7600.16385 (win7_rtm.090713-1255)",
  sModuleProductVersion:                "8.00.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "WOW64",
  iModuleTimeDateStamp:                 0x4C2AE0BB,
  iModuleCheckSum:                      0x005BF65A,
  iModuleImageBase:                     0x74C20000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [
      0x77269, 0x1AC34C, 0x1D9E79, 0x1D9E89, 0x1D9EC9, 0x1D9EE9,
      0x31C3C0, 0x472505],
  aiPopEaxRetOffsets: [
      0x34741, 0x66255, 0x165958, 0x2A4849, 0x357233, 0x357237,
      0x357243, 0x357247, 0x35724B, 0x35724F, 0x357253, 0x357257,
      0x357263, 0x357267, 0x35726B, 0x35726F, 0x357273, 0x357277,
      0x357333, 0x357337, 0x357343, 0x357347, 0x35734B, 0x35734F,
      0x357353, 0x357357, 0x357363, 0x357367, 0x35736B, 0x35736F,
      0x357373, 0x357377, 0x4F3264, 0x4F326B, 0x1403B, 0x25323,
      0x25327, 0x2532B, 0x2532F, 0x42B73, 0xB5D72, 0x156053,
      0x192D7A, 0x26205E, 0x357223, 0x357227, 0x35722B, 0x35722F,
      0x35723B, 0x35723F, 0x35725B, 0x35725F, 0x35727B, 0x357323,
      0x357327, 0x35732B, 0x35732F, 0x35733B, 0x35733F, 0x35735B,
      0x35735F, 0x35737B, 0x3F2678, 0x45665F, 0x4F323C, 0x114FD,
      0x11C33, 0x1CEA9, 0x2024C, 0x25313, 0x25317, 0x2531B,
      0x2531F, 0x2538A, 0x2538E, 0x2D539, 0x30387, 0x3F1F2,
      0x411F6, 0x4179C, 0x417DC, 0x42389, 0x437FB, 0x4B98A,
      0x51C29, 0x55A1F, 0x6AD38, 0x6D27D, 0x7D959, 0x8A17A,
      0x8B6DB, 0xA10C4, 0xA10C8, 0xA11E6, 0xA11EA, 0xA22EA
      /*...274 not shown...*/],
  aiXchgEaxEbxRetOffsets: [
      0x16E02F, 0x2CF6EF, 0x3BED7A, 0x4B8AE3],
  aiXchgEaxEcxRetOffsets: [
      0x10409, 0x1CDF28, 0x2A709A, 0x3623D0, 0x374E02, 0x3D6802,
      0x44FF3B, 0x4B7602, 0x4B8CC2, 0x4EF422],
  aiXchgEaxEdxRetOffsets: [
      0x329E2, 0x4DFE2, 0x13867F, 0x49E4DA, 0x4EF8E5],
  aiXchgEaxEspRetOffsets: [
      0x7644D, 0xD736D, 0x284734, 0x296547, 0x2A3157, 0x345645,
      0x395830, 0x3F5151, 0x394526, 0x39615E, 0x3D333A, 0x3F5122,
      0x3F513B, 0x41266D, 0x1185F, 0x14C09, 0x1AB0D, 0x2F686,
      0x30250, 0x3E4EB, 0x50592, 0x51371, 0x513E6, 0x5A245,
      0x5B7EA, 0x61B40, 0x7EF98, 0x7EFB8, 0xB7BCC, 0xBD91E,
      0xC38BC, 0xCB493, 0xCF153, 0xDCCA1, 0xE3D15, 0xE541A,
      0xFC882, 0xFE815, 0x10094F, 0x1009CB, 0x102295, 0x10C81D,
      0x10F7C2, 0x11FE17, 0x13A646, 0x13B14F, 0x154A10, 0x18AD84,
      0x1BAA78, 0x1D75C4, 0x1DD21B, 0x1EB2FA, 0x1EB515, 0x1EE114,
      0x1EFDF3, 0x1F67DA, 0x1F7E80, 0x1F8CCD, 0x20C0D0, 0x2408FF,
      0x24CE1E, 0x25A662, 0x25A9F2, 0x25CAA4, 0x275ECD, 0x28778F,
      0x2A96BF, 0x2C1D68, 0x2F2CAA, 0x33BE52, 0x347C9E, 0x34F0F2,
      0x355FA4, 0x3577C7, 0x357815, 0x37C034, 0x39610A, 0x3961B3,
      0x396208, 0x3CA26D, 0x3D5B9B, 0x3D80B8, 0x3D9067, 0x3D9649,
      0x3E0BAD, 0x3F51DA, 0x3F51EE, 0x40C0E9, 0x40E1BB, 0x41F491,
      0x43DE01, 0x4851D0, 0x48AC8E, 0x48AC99, 0x48ACA4, 0x4A2DDF
      /*...16 not shown...*/],
  aiXchgEaxEbpRetOffsets: [
      0x13684B, 0x2E6F7A, 0x426736, 0x465A58, 0x72543, 0x11697E,
      0x127D32, 0x182F6B, 0x2E6072, 0x465A20, 0x1D925, 0x1D994,
      0x2B876, 0x3A194, 0x558B1, 0x60703, 0x70A29, 0x114A97,
      0x154A1E, 0x17DD4E, 0x18075F, 0x181EC4, 0x181ED4, 0x181F02,
      0x181F12, 0x181F2E, 0x1CCC37, 0x1CD416, 0x1D72FE, 0x1DB8EC,
      0x1E4609, 0x1E9441, 0x1F4A99, 0x20E18A, 0x282804, 0x2F1B0E,
      0x2FD0BB, 0x2FD0D2, 0x2FD0E9, 0x3079D2, 0x363482, 0x3DAB48,
      0x3F82E5, 0x3FA0F1, 0x400101, 0x50A494, 0x510AA2, 0x510AE6,
      0x5270F6, 0x52D8E2],
  aiXchgEaxEsiRetOffsets: [
      0x5556A, 0x4EDDEF, 0x4EF5A1, 0x4EF905, 0x4EF915],
  aiXchgEaxEdiRetOffsets: [
      0x84DA8, 0x1A78CF, 0x2104CA, 0x4EDD88, 0x4EDD98],
  aiLeaveRetOffsets: [
      0x1364A, 0x1414F, 0x16C7A, 0x16D59, 0x1756E, 0x2346E,
      0x3496B, 0x4364D, 0x43768, 0x43962, 0x46E55, 0x4774E,
      0x83042, 0xA7043, 0xB3276, 0xB464E, 0xB4672, 0xB776F,
      0xC7749, 0xC7875, 0xC7A68, 0xF4A78, 0xF6244, 0x106370,
      0x106C53, 0x114758, 0x116166, 0x126E75, 0x133457, 0x134469,
      0x144270, 0x14456D, 0x146B7A, 0x153669, 0x157230, 0x15756C,
      0x163765, 0x166169, 0x175035, 0x175059, 0x176755, 0x176F34,
      0x177068, 0x177972, 0x186672, 0x193042, 0x194C34, 0x1A7A74,
      0x1D306C, 0x1D4E46, 0x1E534C, 0x203158, 0x213772, 0x21636F,
      0x224662, 0x226843, 0x226A57, 0x243037, 0x264237, 0x276165,
      0x306562, 0x333677, 0x334B30, 0x344151, 0x345934, 0x345958,
      0x345A30, 0x345A54, 0x345A78, 0x347665, 0x34796A, 0x355567,
      0x364252, 0x366941, 0x366D7A, 0x383755, 0x396A30, 0x396A34,
      0x397051, 0x3A3179, 0x3A4867, 0x3A505A, 0x3B694A, 0x3D574E,
      0x3E7254, 0x3E7A52, 0x3F4C39, 0x405374, 0x405530, 0x427335,
      0x436154, 0x437A66, 0x444C71, 0x447143, 0x447167, 0x45557A
      /*...1416 not shown...*/]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "MSHTML",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "8.00.7600.16385 (win7_rtm.090713-1255)",
  sModuleProductVersion:                "8.00.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x64",
  iModuleTimeDateStamp:                 0x4C2AEC75,
  iModuleCheckSum:                      0x008E68C8,
  iModuleImageBase:                     0x7DC00000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [
      0x1F04EB, 0x2137E8, 0x29CF50, 0x309795, 0x543D10, 0x5493AC,
      0x558F5F, 0x558FDB],
  aiPopEaxRetOffsets: [
      0x93763, 0x366856, 0x426539, 0x153F6F, 0x156E23, 0x3A2C47,
      0x422F6A, 0x9554, 0x53702, 0x59D8D, 0x60D4D, 0x708DB,
      0x9B3F2, 0xE7D9E, 0xFDD62, 0xFDDD1, 0x12C93E, 0x12C9BE,
      0x16B035, 0x16B187, 0x16FDE7, 0x17A122, 0x1A5D8D, 0x1B5D1A,
      0x1C4BF5, 0x240D2A, 0x241683, 0x24E6D1, 0x24E75D, 0x2BAC72,
      0x2BE345, 0x3685A3, 0x36CE6A, 0x39A5E9, 0x39B6BD, 0x3A8775,
      0x3AB647, 0x3DB9D1, 0x3F030E, 0x3FA27C, 0x3FDC65, 0x4045EE,
      0x412D1B, 0x414F8D, 0x4197C1, 0x41BAB6, 0x41E927, 0x41F7B3,
      0x441BC1, 0x44BCBF, 0x4738DE, 0x4AC6EC, 0x4B6193, 0x4B6211,
      0x4B6284, 0x4B628B, 0x4BAFD9, 0x4C185E, 0x4C44C9, 0x4D8CDF,
      0x4D8CE6, 0x4E1327, 0x4F097E, 0x4F0A1E, 0x51BEBE, 0x51C00B,
      0x51C6CD, 0x5320FF, 0x53211B, 0x53728E, 0x5372DE, 0x5387EC,
      0x5409C1, 0x540EA4, 0x5446DB, 0x5709BA, 0x679E37, 0x690B62,
      0x6948EF],
  aiXchgEaxEbxRetOffsets: [
      0x73539, 0x425BB9, 0x4BD0BC, 0x6934C1],
  aiXchgEaxEcxRetOffsets: [
      0xB3F2A, 0x49EADB, 0x4D3CAB],
  aiXchgEaxEdxRetOffsets: [
      0x2163DA, 0x642B1A],
  aiXchgEaxEspRetOffsets: [
      0x6E51, 0x1326B, 0x113048, 0x123131, 0x23547A, 0x2D526E,
      0x3B5162, 0x4A3265, 0x606B66, 0x673549, 0x725E, 0x76540,
      0x133120, 0x153F4E, 0x1E5B55, 0x222C48, 0x27254B, 0x272561,
      0x2C605A, 0x30577C, 0x314037, 0x3B2D35, 0x43757B, 0x462046,
      0x4C652F, 0x4F5727, 0x577E66, 0x5D2D35, 0x5E7E50, 0x61395E,
      0x636F27, 0x673621, 0x693C69, 0x693F41, 0x76E7, 0x10DA3,
      0x2D6AF, 0x3FBC9, 0x4999E, 0x4E070, 0x5B449, 0x73CE2,
      0x783BF, 0x7C432, 0x89A66, 0x9E012, 0xA0459, 0xAC007,
      0xD1B9C, 0xD4510, 0xD9D69, 0xDCF8F, 0xEDEEB, 0xEED4C,
      0xF08B3, 0x10BED9, 0x110190, 0x110D01, 0x110EAF, 0x111464,
      0x111A71, 0x113FE4, 0x11807A, 0x119CA4, 0x132685, 0x13681C,
      0x136EA6, 0x13B1D9, 0x1459BE, 0x1578B1, 0x16AA39, 0x171639,
      0x1717D3, 0x17974B, 0x17A95C, 0x187F5B, 0x190D15, 0x19B79F,
      0x19E5CE, 0x19F9D8, 0x1A011C, 0x1A6DA7, 0x1AD330, 0x1D1183,
      0x1DA5D1, 0x1DBB30, 0x1E5A01, 0x1ED6B9, 0x2067E5, 0x208026,
      0x20BB4B, 0x21AA37, 0x250484, 0x268967, 0x271497, 0x2725CB
      /*...101 not shown...*/],
  aiXchgEaxEbpRetOffsets: [
      0x2A6E79, 0x3A6B31, 0x4F5257, 0x5A5276, 0x5028, 0x27D27,
      0x55E7D, 0xB3F2F, 0xB562D, 0x19255A, 0x1B5B2A, 0x222A2F,
      0x4F535F, 0x5A5E36, 0x5A722D, 0x615760, 0x4FE8, 0xDD94,
      0xE82C, 0x1177E, 0x183EB, 0x21324, 0x27BA0, 0x41D4C,
      0x500E0, 0x533F9, 0xBAE13, 0x100058, 0x10A83F, 0x10F8A4,
      0x10FED5, 0x110479, 0x113F14, 0x116308, 0x1254BC, 0x12BF3A,
      0x137F22, 0x13C401, 0x14240F, 0x14C00B, 0x14C2E1, 0x155BEF,
      0x15E260, 0x160592, 0x168023, 0x19E6F8, 0x19E7B9, 0x1AFA8E,
      0x1C4C19, 0x1C6A08, 0x1C9980, 0x1D0D00, 0x1DB939, 0x1DBD65,
      0x1F0148, 0x1F8B62, 0x2002DE, 0x2090D5, 0x21EF28, 0x2333F4,
      0x23FC9C, 0x24AF9C, 0x2513DD, 0x279DD3, 0x292AE7, 0x2951CE,
      0x2A8286, 0x2A83E2, 0x2D87B6, 0x308B40, 0x30EBAF, 0x30F341,
      0x30F41F, 0x3113DD, 0x322CC4, 0x331684, 0x34A44E, 0x34DCE6,
      0x35056F, 0x35EE93, 0x386E07, 0x388E43, 0x390E03, 0x3940C0,
      0x3A52AD, 0x3BDBFB, 0x3CC548, 0x3CFB3C, 0x3FB317, 0x4036F2,
      0x40A7F4, 0x40A87E, 0x4177B9, 0x41E492, 0x43491D, 0x4376AE
      /*...44 not shown...*/],
  aiXchgEaxEsiRetOffsets: [
      0x274B61, 0x497726, 0x1EF706, 0x4DD9A3, 0x4DD9DB, 0x509A8E,
      0x5408D0, 0x6068BD, 0x65FF74],
  aiXchgEaxEdiRetOffsets: [
      0x533625, 0x17D338, 0x255014, 0x4F011B, 0x5F77FA, 0x60DC45],
  aiLeaveRetOffsets: [
      0x5F6E63, 0xC2C74, 0x2BD013]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "jscript.dll",
  sModuleFileVersion:                   "5.7.6002.22145",
  sModuleProductVersion:                "5.7.6002.22145",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x4A842E35,
  iModuleCheckSum:                      0x0008ADCB,
  iModuleImageBase:                     0x75C50000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [
      0xDBF3, 0x311AB, 0x3A3D5, 0x3A3FD, 0x3A42C],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0x59FB2, 0x61416],
  aiXchgEaxEbpRetOffsets: [
      0x3F323, 0x4D9BB, 0x61403],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x4876, 0x554E, 0x6561, 0x667A, 0x7146, 0x16768,
      0x25270, 0x26364, 0x27479, 0x33471, 0x44E6B, 0x64367,
      0x64F37, 0x1443D, 0x15C27, 0x17B21, 0x2213D, 0x24C3C,
      0x25E45, 0x32627, 0x33D2D, 0x5216A, 0x52248, 0x52942,
      0x66065, 0x67060, 0x6777C, 0x4F8A, 0x5AF0, 0x64D8,
      0x65C0, 0x8AA9, 0x9F20, 0x9F94, 0xA43B, 0xAB44,
      0xBDEC, 0xDF28, 0xEE2E, 0xF476, 0xF533, 0xF67A,
      0xF96E, 0xFC37, 0xFDF5, 0xFE7A, 0x102B7, 0x13AF2,
      0x13BA2, 0x145F0, 0x151C3, 0x178CB, 0x179AD, 0x18E8E,
      0x190C5, 0x1C056, 0x1C6DC, 0x1C731, 0x1C778, 0x1C8F8,
      0x1D0C0, 0x1D33F, 0x1D994, 0x1E5EE, 0x1FC50, 0x21777,
      0x22CFA, 0x22DD0, 0x239AC, 0x2DC8E, 0x310E3, 0x3145F,
      0x3330E, 0x336C6, 0x33B0F, 0x33CE8, 0x3F29F, 0x3F369,
      0x3F426, 0x3F456, 0x3F45E, 0x46218, 0x463CE, 0x476EF,
      0x47D89, 0x4AB40, 0x4BCA1, 0x4BDFC, 0x52FF3, 0x557D8,
      0x55A11, 0x55E8B, 0x56703, 0x59074, 0x641E7, 0x644EF
      /*...19 not shown...*/]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows Vista Pro Service Pack 2 en-us (build 6002)",
  sWindowsVersion:                      "6.0",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "jscript.dll",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "5.8.6001.18702",
  sModuleProductVersion:                "5.8.6001.18702",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x4B18B688,
  iModuleCheckSum:                      0x000B27D9,
  iModuleImageBase:                     0x6FC00000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [
      0x3160E],
  aiPopEaxRetOffsets: [
      0x3169D, 0x3C321, 0x5BA87],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0x33D49, 0x33D6B, 0x37226, 0x84822, 0x33DBD, 0x8FC4C,
      0x8FC61, 0x8FCDE],
  aiXchgEaxEbpRetOffsets: [
      0x9535A, 0x6542A, 0x9542B, 0x8FC3E, 0x953B3],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0xDD07, 0x1BEAC, 0x1CB06, 0x21B43, 0x374DF, 0x9788D,
      0x979D2, 0x98251, 0x98415, 0x98503, 0x98FCD, 0x990A1,
      0x9937D, 0x993BE, 0x9A378, 0x9A3E5, 0x9AA94, 0x9AFDD,
      0x9B1B0, 0x9B7DD, 0x9B884, 0x9B8FB, 0x9B942, 0x9BABC,
      0x9BBD1, 0x9BC83, 0x9BFCF, 0x9C0CA, 0x9C32D]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows XP Pro Service Pack 3 en-us (build 2600)",
  sWindowsVersion:                      "5.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x86",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "jscript.dll",
  sModuleFileVersion:                   "5.8.6001.22960",
  sModuleProductVersion:                "5.8.6001.22960",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x86",
  iModuleTimeDateStamp:                 0x4B1F3B68,
  iModuleCheckSum:                      0x000C0224,
  iModuleImageBase:                     0x3D7A0000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [
      0x3160E],
  aiPopEaxRetOffsets: [
      0x3169D, 0x3C321, 0x5BA87],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0x33D49, 0x33D6B, 0x37226, 0x84822, 0x33DBD, 0x8FC4C,
      0x8FC61, 0x8FCDE],
  aiXchgEaxEbpRetOffsets: [
      0x9535A, 0x6542A, 0x9542B, 0x8FC3E, 0x953B3],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0xDD07, 0x1BEAC, 0x1CB06, 0x21B43, 0x374DF, 0x9788D,
      0x979D2, 0x98251, 0x98415, 0x98503, 0x98FCD, 0x990A1,
      0x9937D, 0x993BE, 0x9A378, 0x9A3E5, 0x9AA94, 0x9AFDD,
      0x9B1B0, 0x9B7DD, 0x9B884, 0x9B8FB, 0x9B942, 0x9BABC,
      0x9BBD1, 0x9BC83, 0x9BFCF, 0x9C0CA, 0x9C32D]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "jscript.dll",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "5.8.7600.16385",
  sModuleProductVersion:                "5.8.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "WOW64",
  iModuleTimeDateStamp:                 0x4B1620F9,
  iModuleCheckSum:                      0x000BE4E3,
  iModuleImageBase:                     0x70340000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [
      0x112EB],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0x29832, 0x396EE, 0x39711, 0x39733, 0x39785, 0x88450],
  aiXchgEaxEbpRetOffsets: [
      0x5234, 0x94448, 0x3C06C, 0x4591B, 0x6A9BD],
  aiXchgEaxEsiRetOffsets: [
      0x2B5BB],
  aiXchgEaxEdiRetOffsets: [],
  aiLeaveRetOffsets: [
      0x34A54, 0x96E69, 0x96F57, 0x97A30, 0x12F21, 0x97D7C,
      0x12AF0, 0x12E9C, 0x1688A, 0x342A2, 0x34D91, 0x34E06,
      0x40E6A, 0x41A85, 0x9638D, 0x964F7, 0x96CA3, 0x97B04,
      0x97DC0, 0x9857C, 0x98AC5, 0x98C98, 0x992FA, 0x993A1,
      0x99418, 0x9945F, 0x995DB, 0x99A59, 0x99ACE, 0x99B86,
      0x99F9A]
});
gaoModuleInfos.push({
  sWindowsName:                         "Windows 7 Pro x64 en-us (build 7600)",
  sWindowsVersion:                      "6.1",
  sWindowsLanguage:                     "en-us",
  sWindowsCpuClass:                     "x64",
  iWindowsAllocationGranularity:        0x00010000,
  iWindowsPageSize:                     0x00001000,
  sModuleName:                          "jscript.dll",
  // Please make sure you read http://support.microsoft.com/kb/959441 and
  // The version information below may be incorrect.
  sModuleFileVersion:                   "5.8.7600.16385",
  sModuleProductVersion:                "5.8.7600.16385",
  sModuleLanguage:                      "en-us",
  sModuleSubSystemCpuClass:             "x64",
  iModuleTimeDateStamp:                 0x4B162D87,
  iModuleCheckSum:                      0x000D32F5,
  iModuleImageBase:                     0x76A40000,
  dsiFunctionOffsets: {},
  aiBreakRetOffsets: [],
  aiPopEaxRetOffsets: [
      0x7D5A, 0x3A462, 0x3A488, 0x5B2F0, 0x5B43A, 0x5E220,
      0x7AEBE],
  aiXchgEaxEbxRetOffsets: [],
  aiXchgEaxEcxRetOffsets: [],
  aiXchgEaxEdxRetOffsets: [],
  aiXchgEaxEspRetOffsets: [
      0x3B0DD, 0x4EF7D, 0x53A9F, 0x5E2A9, 0x5E2C1, 0x6769D,
      0x69BAB],
  aiXchgEaxEbpRetOffsets: [
      0x38D77, 0x38DA7, 0x4C4D7, 0x4FB41, 0x5278B, 0x69077,
      0x6BBD9],
  aiXchgEaxEsiRetOffsets: [],
  aiXchgEaxEdiRetOffsets: [
      0x38735],
  aiLeaveRetOffsets: []
});
